Package com.emc.d2fs.interfaces

# Interface IWorkflowService

All Superinterfaces:
  `ID2fsService`

public interface IWorkflowService extends ID2fsService
Workflow management services.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `abortWorkflow(Context context, String id)`
  Abort workflow for specified task
  `boolean`
  `acquireTask(Context context, String id, boolean forceAcquire, boolean forceRead)`
  Manage task acquisition and read state
  `AcquireWorkflowTaskResponse`
  `acquireTaskAndGetState(Context context, String id, boolean forceAcquire, boolean forceRead)`
  Manage task acquisition and read state
  `boolean`
  `addNoteToTask(Context context, String id, String comment)`
  Add note to task
  `boolean`
  `canAbortWorkflow(Context context, String id)`
  Check if user can abort the workflow
  `boolean`
  `canAddTaskNote(Context context, String id)`
  Check if user can add a note to the task
  `boolean`
  `canDelegateTask(Context context, String id)`
  Check if user can delegate the task
  `boolean`
  `canForwardTask(Context context, String id)`
  Check if user can forward the task
  `boolean`
  `canRejectTask(Context context, String id)`
  Check if user can reject the task
  `boolean`
  `checkAttachmentLockState(Context context, String id, List<Attribute> parameters)`
  Check lifecycle
  `boolean`
  `checkLifeCycle(Context context, String id, List<Attribute> parameters)`
  Check lifecycle
  `String`
  `checkPropertyPage(Context context, String id, String operation, String nextTaskId)`
  Check if property page is linked to task operation
  `boolean`
  `checkWorkflowAliases(Context context, String id, List<Attribute> parameters)`
  `boolean`
  `delegateTask(Context context, String id, String user)`
  Delegate task to another user
  `boolean`
  `delegateTaskOnError(Context context, String id)`
  Delegate task to workflow administrator
  `default void`
  `forwardTask(Context context, String id)`
  `List<String>`
  `getConfigurationsNames(Context context, String id)`
  Get workflow configurations list for document
  `String`
  `getTaskFolderLabel(Context context, String id)`
  Get task folder label with unread count
  `String`
  `getTaskMode(Context context, String id, List<Attribute> parameters)`
  Get process task mode (direct, need dialog, need sign off)
  `List<Attribute>`
  `getTaskPermissions(Context context, String taskId)`
  Populate all the Task permissions for the given task id
  `String`
  `getWorkflowDisplayName(Context context, String configName)`
  Get the workflow display name for this user
  `default Map<Integer,Long>`
  `getWorkflowStatusSummary(Context context, String widgetName)`
  `boolean`
  `isManualAcquisitionTask(Context context, String id)`
  Check if task acquisition is manual or automatic
  `boolean`
  `isTaskAcquired(Context context, String id)`
  Check if task is acquired
  `boolean`
  `launchScheduledWorkflow(Context context, String id)`
  Launch a scheduled workflow.
  `String`
  `launchWorkflow(Context context, List<Attribute> parameters)`
  Launch document into workflow
  `void`
  `pauseWorkflow(Context context, String id)`
  `boolean`
  `processTask(Context context, String id, List<Attribute> parameters)`
  Process task by forwarding or rejecting it through workflow
  `void`
  `resumeWorkflow(Context context, String id)`
  `boolean`
  `setTaskPriority(Context context, String id, int priority)`
  Change task priority
  `boolean`
  `setTaskReadState(Context context, String id, boolean read)`
  Change task read state (read/unread)
  `default String`
  `updatePerformer(Context context, String id, List<Attribute> parameters)`
  Update Performer will update the performer list of an alias.
  `boolean`
  `verifyEntryCriteria(Context context, String id, String config)`
  Check if document respond to workflow entry criteria
  `List<Attribute>`
  `verifyEntryCriterias(Context context, List<String> ids, String config)`
  Check if documents respond to workflow entry criteria

  ### Methods inherited from interface com.emc.d2fs.interfaces.ID2fsService

  `isRemote, setRemote`

- ## Method Details

  - ### isTaskAcquired

    boolean isTaskAcquired(Context context, String id) throws Exception
    Check if task is acquired
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of task id
    Returns:
      true is task is acquired
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### isManualAcquisitionTask

    boolean isManualAcquisitionTask(Context context, String id) throws Exception
    Check if task acquisition is manual or automatic
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of task id
    Returns:
      true if task acquisition is manual, false if automatic
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### canForwardTask

    boolean canForwardTask(Context context, String id) throws Exception
    Check if user can forward the task
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of task id
    Returns:
      true if task can be forwarded
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### forwardTask

    default void forwardTask(Context context, String id) throws Exception
    Throws:
      `Exception`

  - ### canRejectTask

    boolean canRejectTask(Context context, String id) throws Exception
    Check if user can reject the task
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of task id
    Returns:
      true if task can be rejected
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### canDelegateTask

    boolean canDelegateTask(Context context, String id) throws Exception
    Check if user can delegate the task
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of task id
    Returns:
      true if task can be delegated
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### canAddTaskNote

    boolean canAddTaskNote(Context context, String id) throws Exception
    Check if user can add a note to the task
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of task id
    Returns:
      true if user can add note to task
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### canAbortWorkflow

    boolean canAbortWorkflow(Context context, String id) throws Exception
    Check if user can abort the workflow
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of task id
    Returns:
      true if workflow can be aborted
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### acquireTaskAndGetState

    AcquireWorkflowTaskResponse acquireTaskAndGetState(Context context, String id, boolean forceAcquire, boolean forceRead) throws Exception
    Manage task acquisition and read state
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of task id
      `forceAcquire` - Boolean value to force ensure task acquisition (in manual acquisition mode)
      `forceRead` - Boolean value to force read state (read or unread)
    Returns:
      `TaskResponse` if process performs without error
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### acquireTask

    boolean acquireTask(Context context, String id, boolean forceAcquire, boolean forceRead) throws Exception
    Manage task acquisition and read state
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of task id
      `forceAcquire` - Boolean value to force ensure task acquisition (in manual acquisition mode)
      `forceRead` - Boolean value to force read state (read or unread)
    Returns:
      true if process performs without error
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### checkLifeCycle

    boolean checkLifeCycle(Context context, String id, List<Attribute> parameters) throws Exception
    Check lifecycle
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of task id
      `parameters` -
    Returns:
      true if LifeCycle constraints are fulfilled
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### checkPropertyPage

    String checkPropertyPage(Context context, String id, String operation, String nextTaskId) throws Exception
    Check if property page is linked to task operation
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of task id
      `operation` - String value of operation type
      `nextTaskId` - String value of next task id
    Returns:
      String value of property page name
    Throws:
      `Exception`
    Since:
      4.2.15

  - ### checkWorkflowAliases

    boolean checkWorkflowAliases(Context context, String id, List<Attribute> parameters) throws Exception
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` -
      `parameters` -
    Returns:
      true if workflow performers are consistent
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### processTask

    boolean processTask(Context context, String id, List<Attribute> parameters) throws Exception
    Process task by forwarding or rejecting it through workflow
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of task id
      `parameters` - Attribute list
    Returns:
      true if process performs without error
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### addNoteToTask

    boolean addNoteToTask(Context context, String id, String comment) throws Exception
    Add note to task
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of task id
      `comment` - Note content
    Returns:
      true if process performs without error
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### delegateTask

    boolean delegateTask(Context context, String id, String user) throws Exception
    Delegate task to another user
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of task id
      `user` - Targeted user
    Returns:
      true if process performs without error
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### checkAttachmentLockState

    boolean checkAttachmentLockState(Context context, String id, List<Attribute> parameters) throws Exception
    Check lifecycle
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of task id
      `parameters` -
    Returns:
      true if workflowMasterDocument is in locked state
    Throws:
      `Exception`
    Since:
      16.4

  - ### delegateTaskOnError

    boolean delegateTaskOnError(Context context, String id) throws Exception
    Delegate task to workflow administrator
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of task id
    Returns:
      true if process performs without error
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### setTaskReadState

    boolean setTaskReadState(Context context, String id, boolean read) throws Exception
    Change task read state (read/unread)
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of task id
      `read` - boolean, true for read, false for unread
    Returns:
      true if process performs without error
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### setTaskPriority

    boolean setTaskPriority(Context context, String id, int priority) throws Exception
    Change task priority
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of task id
      `priority` - Priority level from 0 to 5
    Returns:
      true if process performs without error
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### getTaskFolderLabel

    String getTaskFolderLabel(Context context, String id) throws Exception
    Get task folder label with unread count
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of task folder id
    Returns:
      String value of task folder label
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### verifyEntryCriteria

    boolean verifyEntryCriteria(Context context, String id, String config) throws Exception
    Check if document respond to workflow entry criteria
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of document id
      `config` - String value of workflow configuration name
    Returns:
      true if document respond to criteria
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### verifyEntryCriterias

    List<Attribute> verifyEntryCriterias(Context context, List<String> ids, String config) throws Exception
    Check if documents respond to workflow entry criteria
    Parameters:
      `context` - `Context` object containing informations about client/session
      `ids` - List of String value of document id
      `config` - String value of workflow configuration name
    Returns:
      List of `Attribute` which returns errors of entry criteria for each id.
    Throws:
      `Exception`
    Since:
      4.2.1

  - ### launchWorkflow

    String launchWorkflow(Context context, List<Attribute> parameters) throws Exception
    Launch document into workflow
    Parameters:
      `context` - `Context` object containing informations about client/session
      `parameters` - `Attribute` list of workflow parameters

      Parameters:

      - config: DF_STRING - Workflow config (ie. "WF HR Read and Understood")
      - name: DF_STRING - Workflow tracker name (ie. "WF HR Read and Understood" + new Date())
      - id: DF_STRING - Id or list of ids of documents in the workflow. (separated by AttributeUtils.SEPARATOR_VALUE)
        (optional)
      - add_document_id: DF_STRING - Id or list of ids of workflow attachments.
      - end_of_workflow: DF_STRING - Date of scheduled end. Notification will be sent before end.
      - launch_date: DF_STRING - Date of scheduled start. Launch now if empty.
      - launch_notification: DF_BOOLEAN - True to send notification on start.
      - notification: DF_STRING - Note to accompany the workflow instance.
        (workflow specific)
      - {Performer Alias Name}: DF_STRING -- Attribute named for the workflow configuration's performer alias. Values are workflow performers (separated by AttributeUtils.SEPARATOR_VALUE)
        For Example 'WF HR Read and Understood' config:
      - Recipients: DF_STRING - List of workflow performer values, one attribute for each of WF alias. In this case, it is a simple WF with only one manual task where the performer alias is named "Recipients". (separated by AttributeUtils.SEPARATOR_VALUE)
    Returns:
      String value of launch message
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### abortWorkflow

    String abortWorkflow(Context context, String id) throws Exception
    Abort workflow for specified task
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of task id
    Returns:
      true if process performs without error
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### pauseWorkflow

    void pauseWorkflow(Context context, String id) throws Exception
    Throws:
      `Exception`

  - ### resumeWorkflow

    void resumeWorkflow(Context context, String id) throws Exception
    Throws:
      `Exception`

  - ### getTaskMode

    String getTaskMode(Context context, String id, List<Attribute> parameters) throws Exception
    Get process task mode (direct, need dialog, need sign off)
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of task id
      `operation` - String value of operation type (forward, reject)
    Returns:
      String value of mode
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### launchScheduledWorkflow

    boolean launchScheduledWorkflow(Context context, String id) throws Exception
    Launch a scheduled workflow.
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of workflow tracker id
    Returns:
      true if process performs without error
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### getConfigurationsNames

    List<String> getConfigurationsNames(Context context, String id) throws Exception
    Get workflow configurations list for document
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of document id
    Returns:
      String list of configuration names
    Throws:
      `Exception`
    Since:
      4.0.1

  - ### getWorkflowDisplayName

    String getWorkflowDisplayName(Context context, String configName) throws Exception
    Get the workflow display name for this user
    Parameters:
      `context` -
      `configName` -
    Returns:
    Throws:
      `Exception`

  - ### getTaskPermissions

    List<Attribute> getTaskPermissions(Context context, String taskId) throws Exception
    Populate all the Task permissions for the given task id
    Parameters:
      `context` - `Context` object containing informations about client/session
      `taskId` - String value of task id
    Returns:
    Throws:
      `Exception`

  - ### updatePerformer

    default String updatePerformer(Context context, String id, List<Attribute> parameters) throws Exception
    Update Performer will update the performer list of an alias.
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of task id or Workflow id
      `parameters` - `Attribute` list of task performers and alias name.
    Returns:
      String value of success or failure
    Throws:
      `Exception`
    Since:
      20.2

  - ### getWorkflowStatusSummary

    default Map<Integer,Long> getWorkflowStatusSummary(Context context, String widgetName) throws Exception
    Throws:
      `Exception`